TYPE FastStr = STRING[255];

CONST InversStartAdres = $A00;

VAR PatternNamePage  : BYTE;
    PatternGenPage   : BYTE;
    Lines26Half      : BYTE;

    SchermBuffer     : ARRAY [0..2047] OF BYTE;
    LastMenuVDPPage  : BYTE;
    LastMenuVDPAdres : INTEGER;

PROCEDURE Read_VDPInl;
{ IN A=vdp nummer
     A:=register inhoud }
BEGIN
  INLINE($DD/$21/$F3DF/         {    LD IX,0F3DFH   }
         $FE/$08/               {    CP 8           }
         $38/$06/               {    JR C,OK        }
         $DD/$21/$FFE7/         {    LD IX,0F3DFH   }
         $D6/$08/               {    SUB 8          }
         $32/*+4/               { OK:LD (PC+4),A    }
         $DD/$7E/$00)           {    LD A,(IX+d)    }
END;

FUNCTION Read_VDP(num : BYTE) : BYTE;
BEGIN
  INLINE($3A/num/          { LD A,num          }
         $CD/Read_VDPInl/  { CALL Read_VDPInl  }
         $6F/              { LD L,A            }
         $26/$00/          { LD H,0            }
         $C9)              { RET               }
END;

PROCEDURE Write_VDPInl;
{ IN A=data vdp reg
     B=vdp nummer }
BEGIN
  INLINE($F3/            {    DI             }
         $F5/            {    PUSH AF        }
         $D3/$99/        {    OUT (99H),A    }
         $78/            {    LD A,B         }
         $F6/$80/        {    OR 80H         }
         $D3/$99/        {    OUT (99H),A    }
         $E6/$7F/        {    AND 07FH       }
         $DD/$21/$F3DF/  {    LD IX,0F3DFH   }
         $FE/$08/        {    CP 8           }
         $38/$06/        {    JR C,OK        }
         $DD/$21/$FFE7/  {    LD IX,0F3DFH   }
         $D6/$08/        {    SUB 8          }
         $32/*+5/        { OK:LD (PC+5),A    }
         $F1/            {    POP AF         }
         $DD/$77/$00/    {    LD (IX+d),A    }
         $FB)            {    EI             }
END;

PROCEDURE Write_VDP(num,data : BYTE);
BEGIN
  INLINE($3A/num/          { LD A,(num)        }
         $47/              { LD B,A            }
         $3A/data/         { LD A,(data)       }
         $CD/Write_VDPInl) { CALL Write_VDPInl }
END;

PROCEDURE Init_VPoke;
{ IN HL    = adres
     Carry = pagina (0 of 1) }
BEGIN
  INLINE($7C/       { LD A,H        }
         $17/       { RLA           }
         $17/       { RLA           }
         $17/       { RLA           }
         $E6/$07/   { AND 7         }
         $F3/       { DI            }
         $D3/$99/   { OUT(99H),A    }
         $3E/142/   { LD A,142 (14) }
         $D3/$99/   { OUT(99H),A    }
         $7D/       { LD A,L        }
         $D3/$99/   { OUT(99H),A    }
         $7C/       { LD A,H        }
         $E6/$3F/   { AND 3FH       }
         $F6/$40/   { OR 40H        }
         $D3/$99)   { OUT (99H),A   }
END;

PROCEDURE Init_VPeek;
{ IN HL    = adres
     Carry = pagina (0 of 1) }
BEGIN
  INLINE($7C/       { LD A,H        }
         $17/       { RLA           }
         $17/       { RLA           }
         $17/       { RLA           }
         $E6/$07/   { AND 7         }
         $F3/       { DI            }
         $D3/$99/   { OUT(99H),A    }
         $3E/142/   { LD A,142 (14) }
         $D3/$99/   { OUT(99H),A    }
         $7D/       { LD A,L        }
         $D3/$99/   { OUT(99H),A    }
         $7C/       { LD A,H        }
         $E6/$3F/   { AND 3FH       }
         $D3/$99)   { OUT (99H),A   }
END;

PROCEDURE Maal80Inl;
{ IN      HL
  OUT     HL:=HL*80
  WIJZIGD DE       }
BEGIN
  INLINE($29/   { ADD HL,HL }
         $29/   { ADD HL,HL }
         $29/   { ADD HL,HL }
         $29/   { ADD HL,HL }
         $E5/   { PUSH HL   }
         $29/   { ADD HL,HL }
         $29/   { ADD HL,HL }
         $D1/   { POP DE    }
         $19)   { ADD HL,DE }
END;

PROCEDURE CalcPageAdres;
{ IN  A  = page nummer
  OUT HL = adres
      A  = page nummer (0,1) }
BEGIN
  INLINE($E6/$1F/          { AND 1FH       }
         $07/              { RLCA          }
         $07/              { RLCA          }
         $07/              { RLCA          }
         $17/              { RLA           }
         $67/              { LD H,A        }
         $2E/$00/          { LD L,0        }
         $17)              { RLA           }
END;

PROCEDURE CalcPatternAdres;
{ IN A  = pattern set nummer
     HL = adres
     A  = page (0,1) }
BEGIN
  INLINE($E6/$3F/             { AND 3FH     }
         $67/                 { LD H,A      }
         $2E/$00/             { LD L,0      }
         $AF/                 { XOR A       }
         $29/                 { ADD HL,HL   }
         $29/                 { ADD HL,HL   }
         $29/                 { ADD HL,HL   }
         $17)                 { RLA         }
END;

PROCEDURE Screen0Page(num : BYTE);
BEGIN
  INLINE($3A/num/              { LD A,(num)             }
         $E6/$1F/              { AND 31                 }
         $32/PatternNamePage/  { LD (PatternNamePage),A }
         $07/                  { RLCA                   }
         $07/                  { RLCA                   }
         $F6/$03/              { OR 3                   }
         $06/$02/              { LD B,2                 }
         $CD/Write_VDPInl/     { CALL Write_VDPInl      }
         $3A/num/              { LD A,(num)             }
         $FE/$04/              { CP 4                   }
         $D0/                  { RET NC                 }
         $07/                  { RLCA                   }
         $07/                  { RLCA                   }
         $07/                  { RLCA                   }
         $07/                  { RLCA                   }
         $67/                  { LD H,A                 }
         $2E/$00/              { LD L,0                 }
         $22/$22/$F9)          { LD (0F922H),HL         }
END;

PROCEDURE Screen0Patterns(num : BYTE);
BEGIN
  INLINE($3A/num/              { LD A,(num)            }
         $E6/$3F/              { AND 03FH              }
         $32/PatternGenPage/   { LD (PatternGenPage),A }
         $06/$04/              { LD B,4                }
         $CD/Write_VDPInl)     { CALL Write_VDPInl     }
END;

PROCEDURE ChangePatterns(sett,num,aantal : BYTE;
                         adres           : INTEGER);
BEGIN
  INLINE($3A/num/               {    LD A,(num)            }
         $6F/                   {    LD L,A                }
         $26/$00/               {    LD H,0                }
         $29/                   {    ADD HL,HL             }
         $29/                   {    ADD HL,HL             }
         $29/                   {    ADD HL,HL             }
         $EB/                   {    EX DE,HL              }
         $3A/sett/              {    LD A,(sett)           }
         $CD/CalcPatternAdres/  {    CALL CalcPatternAdres }
         $19/                   {    ADD HL,DE             }
         $1F/                   {    RRA                   }
         $CD/Init_Vpoke/        {    CALL Init_Vpoke       }
         $2A/adres/             {    LD HL,(adres)         }
         $3A/aantal/            {    LD A,(aantal)         }
         $01/$98/$08/           { L1:LD BC,0898H           }
         $ED/$B3/               {    OTIR                  }
         $3D/                   {    DEC A                 }
         $20/$F8/               {    JR NZ,L1              }
         $FB)                   {    EI                    }
END;

PROCEDURE GetPatterns(sett,num,aantal : BYTE;
                      adres           : INTEGER);
BEGIN
  INLINE($3A/num/               {    LD A,(num)            }
         $6F/                   {    LD L,A                }
         $26/$00/               {    LD H,0                }
         $29/                   {    ADD HL,HL             }
         $29/                   {    ADD HL,HL             }
         $29/                   {    ADD HL,HL             }
         $EB/                   {    EX DE,HL              }
         $3A/sett/              {    LD A,(sett)           }
         $CD/CalcPatternAdres/  {    CALL CalcPatternAdres }
         $19/                   {    ADD HL,DE             }
         $1F/                   {    RRA                   }
         $CD/Init_VPeek/        {    CALL Init_VPeek       }
         $2A/adres/             {    LD HL,(adres)         }
         $3A/aantal/            {    LD A,(aantal)         }
         $01/$98/$08/           { L1:LD BC,0898H           }
         $ED/$B2/               {    INIR                  }
         $3D/                   {    DEC A                 }
         $20/$F8/               {    JR NZ,L1              }
         $FB)                   {    EI                    }
END;

PROCEDURE Clear_Screen(num : BYTE);
BEGIN
  INLINE($3A/num/              {     LD A,(num)            }
         $CD/CalcPageAdres/    {     CALL CalcPageAdres    }
         $1F/                  {     RRA                   }
         $CD/Init_Vpoke/       {     CALL Init_VPoke       }
         $01/$07/$00/          {     LD BC,7               }
         $3E/ 32/              {     LD A,32               }
         $D3/$98/              { L1: OUT (98H),A           }
         $10/$FC/              {     DJNZ L1               }
         $0D/                  {     DEC C                 }
         $20/$F9/              {     JR NZ,L1              }
         $06/$80/              {     LD B,128              }
         $D3/$98/              { L2: OUT (98H),A           }
         $10/$FC/              {     DJNZ L2               }
         $3A/Lines26Half/      {     LD A,(Lines26Half)    }
         $B7/                  {     OR A                  }
         $28/$08/              {     JR Z,L4               }
         $3E/ 32/              {     LD A,32               }
         $06/240/              {     LD B,240              }
         $D3/$98/              { L3: OUT (98H),A           }
         $10/$FC/              {     DJNZ L3               }
         $FB)                  { L4: EI                    }
END;

PROCEDURE Fast_Str(x,y,page : BYTE;
                   st       : FastStr);
BEGIN
  INLINE($3A/y/                    { LD A,(y)                 }
         $6F/                      { LD L,A                   }
         $26/$00/                  { LD H,0                   }
         $CD/Maal80Inl/            { CALL Maal80Inl           }
         $3A/x/                    { LD A,(x)                 }
         $5F/                      { LD E,A                   }
         $16/$00/                  { LD D,0                   }
         $19/                      { ADD HL,DE                }
         $EB/                      { EX DE,HL                 }
         $3A/page/                 { LD A,(page)              }
         $CD/CalcPageAdres/        { CALL CalcPageAdres       }
         $19/                      { ADD HL,DE                }
         $1F/                      { RRA                      }
         $CD/Init_VPoke/           { CALL Init_Vpoke          }
         $21/st/                   { LD HL,st                 }
         $46/                      { LD B,(HL)                }
         $23/                      { INC HL                   }
         $0E/$98/                  { LD C,98H                 }
         $ED/$B3/                  { OTIR                     }
         $FB)                      { EI                       }
END;

PROCEDURE InitVDPStack(adres : INTEGER;
                         page  : BYTE);
BEGIN
  Lines26Half     :=Read_VDP(9) AND $80;
  LastMenuVDPAdres:=adres;
  LastMenuVDPPage :=page AND 1
END;

PROCEDURE Lines27;
BEGIN
  INLINE($3E/$09/            { LD A,9              }
         $CD/Read_VDPInl/    { CALL Read_VDPInl    }
         $F6/$80/            { OR 80H              }
         $06/$09/            { LD B,9              }
         $CD/Write_VDPInl/   { CALL Write_VDPInl   }
         $3E/$80/            { LD A,80H            }
         $32/Lines26Half/    { LD (Lines26Half),A  }
         $3E/27/             { LD A,27             }
         $32/$F3B1)          { LD (0F3B1H),A       }
END;

PROCEDURE Lines24;
BEGIN
  INLINE($3E/$09/            { LD A,9              }
         $CD/Read_VDPInl/    { CALL Read_VDPInl    }
         $E6/$7F/            { AND 7FH             }
         $06/$09/            { LD B,9              }
         $CD/Write_VDPInl/   { CALL Write_VDPInl   }
         $AF/                { XOR A               }
         $32/Lines26Half/    { LD (Lines26Half),A  }
         $3E/ 24/            { LD A,24             }
         $32/$F3B1)          { LD (0F3B1H),A       }
END;

PROCEDURE CursorBack;
BEGIN
  INLINE($3A/$F3DC/                      { LD A,(0F3DCH)          }
         $6F/                            { LD L,A                 }
         $26/$00/                        { LD H,0                 }
         $CD/Maal80Inl/                  { CALL Maal80Inl         }
         $3A/$F3DD/                      { LD A,(0F3DDH)          }
         $5F/                            { LD E,A                 }
         $16/$00/                        { LD D,0                 }
         $19/                            { ADD HL,DE              }
         $11/ 81/$00/                    { LD DE,81               }
         $B7/                            { OR A                   }
         $ED/$52/                        { SBC HL,DE              }
         $ED/$5B/$22/$F9/                { LD DE,($F922H)         }
         $19/                            { ADD HL,DE              }
         $B7/                            { OR A                   }
         $CD/Init_VPeek/                 { CALL Init_VPeek        }
         $DB/$98/                        { IN (98H),A             }
         $FE/$FF/                        { CP 255                 }
         $C8/                            { RET Z                  }
         $32/$CC/$FB);                   { LD (0FBCCH),A          }
  GOTOXY(MEM[$F3DD],MEM[$F3DC])
END;

PROCEDURE WriteVDPBytes(aantal : INTEGER);
BEGIN
  INLINE($2A/LastMenuVDPAdres/   {    LD HL,(LastMenuVDPAdres) }
         $3A/LastMenuVDPPage/    {    LD A,(LastMenuVDPPage)   }
         $1F/                    {    RRA                      }
         $CD/Init_VPoke/         {    CALL Init_VPoke          }
         $21/SchermBuffer/       {    LD HL,SchermBuffer       }
         $01/$98/$00/            {    LD BC,98H                }
         $ED/$5B/aantal/         {    LD DE,(aantal)           }
         $AF/                    { L1:XOR A                    }
         $B2/                    {    OR D                     }
         $28/$05/                {    JR Z,L2                  }
         $ED/$B3/                {    OTIR                     }
         $15/                    {    DEC D                    }
         $18/$F7/                {    JR L1                    }
         $7B/                    { L2:LD A,E                   }
         $B7/                    {    OR A                     }
         $28/$03/                {    JR Z,L3                  }
         $47/                    {    LD B,A                   }
         $ED/$B3/                {    OTIR                     }
         $FB/                    { L3:EI                       }
         $2A/LastMenuVDPAdres/   {    LD HL,(LastMenuVDPAdres) }
         $ED/$5B/aantal/         {    LD DE,(aantal)           }
         $19/                    {    ADD HL,DE                }
         $22/LastMenuVDPAdres/   {    LD (LastMenuVDPAdres),HL }
         $3A/LastMenuVDPPage/    {    LD A,(LastMenuVDPPage)   }
         $CE/$00/                {    ADC A,0                  }
         $32/LastMenuVDPPage)    {    LD (LastMenuVDPPage),A   }
END;

PROCEDURE ReadVDPBytes(aantal : INTEGER);
BEGIN
  INLINE($2A/LastMenuVDPAdres/   {    LD HL,(LastMenuVDPAdres) }
         $3A/LastMenuVDPPage/    {    LD A,(LastMenuVDPPage)   }
         $ED/$5B/aantal/         {    LD DE,(aantal)           }
         $B7/                    {    OR A                     }
         $ED/$52/                {    SBC HL,DE                }
         $DE/$00/                {    SBC A,0                  }
         $32/LastMenuVDPPage/    {    LD (LastMenuVDPPage),A   }
         $22/LastMenuVDPAdres/   {    LD (LastMenuVDPAdres),HL }
         $1F/                    {    RRA                      }
         $CD/Init_VPeek/         {    CALL Init_VPeek          }
         $21/SchermBuffer/       {    LD HL,SchermBuffer       }
         $01/$98/$00/            {    LD BC,98H                }
         $AF/                    { L1:XOR A                    }
         $B2/                    {    OR D                     }
         $28/$05/                {    JR Z,L2                  }
         $ED/$B2/                {    INIR                     }
         $15/                    {    DEC D                    }
         $18/$F7/                {    JR L1                    }
         $7B/                    { L2:LD A,E                   }
         $B7/                    {    OR A                     }
         $28/$03/                {    JR Z,L3                  }
         $47/                    {    LD B,A                   }
         $ED/$B2/                {    INIR                     }
         $FB)                    { L3:EI                       }
END;

PROCEDURE SaveScreen(x1,y1,x2,y2,page : BYTE);
VAR breed,hoog : BYTE;
    start      : INTEGER;
BEGIN
  breed:=SUCC(x2-x1);
  hoog :=SUCC(y2-y1);
  INLINE($3A/y1/               {    LD A,(y1)             }
         $6F/                  {    LD L,A                }
         $26/$00/              {    LD H,0                }
         $CD/Maal80Inl/        {    CALL Maal80Inl        }
         $3A/x1/               {    LD A,(x1)             }
         $5F/                  {    LD E,A                }
         $16/$00/              {    LD D,0                }
         $19/                  {    ADD HL,DE             }
         $22/start/            {    LD (start),HL         }
         $EB/                  {    EX DE,HL              }
         $21/SchermBuffer/     {    LD HL,SchermBuffer    }
         $73/                  {    LD (HL),E             }
         $23/                  {    INC HL                }
         $72/                  {    LD (HL),D             }
         $23/                  {    INC HL                }

         $3A/hoog/             {    LD A,(hoog)           }
         $5F/                  {    LD E,A                }
         $77/                  {    LD (HL),A             }
         $23/                  {    INC HL                }
         $3A/breed/            {    LD A,(breed)          }
         $57/                  {    LD D,A                }
         $77/                  {    LD (HL),A             }
         $23/                  {    INC HL                }
         $0E/$98/              {    LD C,98H              }

         $D9/                  {    EXX                   }
         $3A/page/             {    LD A,(page)           }
         $CD/CalcPageAdres/    {    CALL CalcPageAdres    }
         $ED/$5B/start/        {    LD DE,(start)         }
         $19/                  {    ADD HL,DE             }
         $11/ 80/$00/          {    LD DE,80              }
         $D9/                  {    EXX                   }
         $1F/                  {    RRA                   }

         $D9/                  { L1:EXX                   }
         $F5/                  {    PUSH AF               }
         $CD/Init_VPeek/       {    CALL Init_VPeek       }
         $19/                  {    ADD HL,DE             }
         $D9/                  {    EXX                   }
         $42/                  {    LD B,D                }
         $ED/$B2/              {    INIR                  }
         $FB/                  {    EI                    }
         $F1/                  {    POP AF                }
         $1D/                  {    DEC E                 }
         $20/$F1/              {    JR NZ,L1              }

         $11/SchermBuffer/     {    LD DE,SchermBuffer    }
         $B7/                  {    OR A                  }
         $ED/$52/              {    SBC HL,DE             }
         $22/start);           {    LD (start),HL         }

  WriteVDPBytes(start);
  INLINE($21/InversStartAdres/ {    LD HL,InversStartAdres }
         $B7/                  {    OR A                   }
         $CD/Init_VPeek/       {    CALL Init_VPeek        }
         $01/$98/250/          {    LD BC,..               }
         $21/SchermBuffer/     {    LD HL,SchermBuffer     }
         $ED/$B2/              {    INIR                   }
         $06/ 20/              {    LD B,20                }
         $ED/$B2/              {    INIR                   }
         $FB);
  WriteVDPBytes(270);
  start:=start+270;
  SchermBuffer[0]:=LO(start);
  SchermBuffer[1]:=HI(start);
  WriteVDPBytes(2)
END;

PROCEDURE RestoreScreen(page : BYTE);
VAR oud  : REAL;
    size : INTEGER;
BEGIN
  ReadVDPBytes(2);
  size:=SchermBuffer[1]*256+SchermBuffer[0];
  ReadVDPBytes(270);
  INLINE($21/InversStartAdres/ {    LD HL,InversStartAdres }
         $B7/                  {    OR A                   }
         $CD/Init_VPoke/       {    CALL Init_VPoke        }
         $01/$98/250/          {    LD BC,..               }
         $21/SchermBuffer/     {    LD HL,SchermBuffer     }
         $ED/$B3/              {    OTIR                   }
         $06/ 20/              {    LD B,20                }
         $ED/$B3/              {    OTIR                   }
         $FB);                 {    EI                     }
  ReadVDPBytes(size-270);
  INLINE($21/SchermBuffer/     {    LD HL,SchermBuffer    }
         $5E/                  {    LD E,(HL)             }
         $23/                  {    INC HL                }
         $56/                  {    LD D,(HL)             }
         $23/                  {    INC HL                }
         $D5/                  {    PUSH DE               }
         $D9/                  {    EXX                   }
         $3A/page/             {    LD A,(page)           }
         $CD/CalcPageAdres/    {    CALL CalcPageAdres    }
         $D1/                  {    POP DE                }
         $19/                  {    ADD HL,DE             }
         $11/ 80/$00/          {    LD DE,80              }
         $D9/                  {    EXX                   }

         $5E/                  {    LD E,(HL)             }
         $23/                  {    INC HL                }
         $56/                  {    LD D,(HL)             }
         $23/                  {    INC HL                }
         $0E/$98/              {    LD C,98H              }
         $1F/                  {    RRA                   }

         $D9/                  { L1:EXX                   }
         $F5/                  {    PUSH AF               }
         $CD/Init_VPoke/       {    CALL Init_VPoke       }
         $19/                  {    ADD HL,DE             }
         $D9/                  {    EXX                   }
         $42/                  {    LD B,D                }
         $ED/$B3/              {    OTIR                  }
         $FB/                  {    EI                    }
         $F1/                  {    POP AF                }
         $1D/                  {    DEC E                 }
         $20/$F1)              {    JR NZ,L1              }
END;
